package com.gemstone.android.gbjtest;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.content.SharedPreferences;

import com.gemstone.android.gbjtest.GbjTestCommandActivity;

/**
 *  Main GbjTest Activity:  Login parameter window
 *
 */
public class GbjTestActivity extends Activity {

	/** Static Declarations */
	static SharedPreferences Prefs;
	static SharedPreferences.Editor Edit;
    static TextView ResultView;
    static String IpAddress;
    static String StoneName;
    static String NetldiPort;
    static String UserName;
    static String Password;
    
   
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        // setup preference fetcher and editor
        Prefs = getPreferences(MODE_PRIVATE);
        Edit = Prefs.edit( );
		
		// retrieve parameter info from preferences
		IpAddress  = Prefs.getString("IpAddress", "");
		StoneName  = Prefs.getString("StoneName", "");
		NetldiPort = Prefs.getString("NetldiPort", "");
		UserName   = Prefs.getString("UserName", "");
		Password   = Prefs.getString("Password", "");
		
		// setup text fields with retrieved parameters
		((TextView)findViewById(R.id.ipAddressContents)).setText(IpAddress);
		((TextView)findViewById(R.id.stoneNameContents)).setText(StoneName);
		((TextView)findViewById(R.id.netldiPortContents)).setText(NetldiPort);
		((TextView)findViewById(R.id.usernameContents)).setText(UserName);
		((TextView)findViewById(R.id.passwordContents)).setText(Password);

		// setup login button
        ((Button)findViewById(R.id.loginButton)).setOnClickListener(new OnClickListener( ) {
        	
        		public void onClick(View v) {
        			
        			// fetch parameter info from window
        			IpAddress  = ((TextView)findViewById(R.id.ipAddressContents)).getText().toString();   
        			StoneName  = ((TextView)findViewById(R.id.stoneNameContents)).getText().toString();
        			NetldiPort = ((TextView)findViewById(R.id.netldiPortContents)).getText().toString();
        			UserName   = ((TextView)findViewById(R.id.usernameContents)).getText().toString();
        			Password   = ((TextView)findViewById(R.id.passwordContents)).getText().toString();
        			
        			// record back to preferences
        			Edit.putString("IpAddress",  IpAddress);
        			Edit.putString("StoneName",  StoneName);
        			Edit.putString("NetldiPort", NetldiPort);
        			Edit.putString("UserName",   UserName);
        			Edit.putString("Password",   Password);
        			Edit.commit();
        			
        			String loginResult = GSInterface.login(IpAddress, StoneName, NetldiPort, 
        													UserName, Password);
        			
        			((TextView)findViewById(R.id.resultText)).setText(loginResult);

        			if (loginResult.charAt(0) != 'P') {  // start of word 'Problem'
        				startActivityForResult(new Intent(getApplicationContext(), GbjTestCommandActivity.class), 0);
        			}}});
        
        // setup other label buttons to clear fields when clicked..
        
        ((Button)findViewById(R.id.ipAddressLabel)).setOnClickListener(new OnClickListener( ) {
    		public void onClick(View v) {
    	        ((TextView)findViewById(R.id.ipAddressContents)).setText("");
    		}});
        
        ((Button)findViewById(R.id.stoneNameLabel)).setOnClickListener(new OnClickListener( ) {
    		public void onClick(View v) {
    	        ((TextView)findViewById(R.id.stoneNameContents)).setText("");
    		}});
        
        ((Button)findViewById(R.id.netldiPortLabel)).setOnClickListener(new OnClickListener( ) {
    		public void onClick(View v) {
    	        ((TextView)findViewById(R.id.netldiPortContents)).setText("");
    		}});
        
        ((Button)findViewById(R.id.usernameLabel)).setOnClickListener(new OnClickListener( ) {
    		public void onClick(View v) {
    	        ((TextView)findViewById(R.id.usernameContents)).setText("");
    		}});
        
        ((Button)findViewById(R.id.passwordLabel)).setOnClickListener(new OnClickListener( ) {
    		public void onClick(View v) {
    	        ((TextView)findViewById(R.id.passwordContents)).setText("");
    		}});
        
        GSInterface.initialize( );
    	}
    
    public void onDestroy( ) {
    	
    	super.onDestroy( );
    	// make sure we don't leave a session logged in..
    	// (would leave the GBJ polling thread running)
    	GSInterface.logout( );
    }

        
}